Blockly.JavaScript['big_constant'] = function(block) {
  var text_const = block.getFieldValue('CONST');
  var code = 'new Big(' + text_const + ')';
  return [code, Blockly.JavaScript.ORDER_NEW];
};




Blockly.JavaScript['big_eq'] = function(block) {
  var variable_big1 = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('BIG1'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_big1 + '.eq(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_EQUALITY];
};
Blockly.JavaScript['big_gt'] = function(block) {
  var variable_big1 = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('BIG1'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_big1 + '.gt(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_EQUALITY];
};

Blockly.JavaScript['big_gte'] = function(block) {
  var variable_big1 = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('BIG1'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_big1 + '.gte(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_EQUALITY];
};

Blockly.JavaScript['big_lt'] = function(block) {
  var variable_big1 = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('BIG1'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_big1 + '.lt(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_EQUALITY];
};

Blockly.JavaScript['big_lte'] = function(block) {
  var variable_big1 = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('BIG1'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_big1 + '.lte(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_EQUALITY];
};



Blockly.JavaScript['big_abs'] = function(block) {
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_name + '.abs()';
  return [code, Blockly.JavaScript.ORDER_FUNCTION_CALL];
};

Blockly.JavaScript['big_sqrt'] = function(block) {
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_name + '.sqrt()';
  return [code, Blockly.JavaScript.ORDER_FUNCTION_CALL];
};


Blockly.JavaScript['big_plus'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.plus(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_ADDITION];
};
Blockly.JavaScript['big_moins'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.minus(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_SUBTRACTION];
};
Blockly.JavaScript['big_fois'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.times(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_MULTIPLICATION];
};
Blockly.JavaScript['big_sur'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.div(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_DIVISION];
};
Blockly.JavaScript['big_invsur'] = function(block) {
  var text_big1 = block.getFieldValue('BIG1');
  var variable_big2 = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('BIG2'), Blockly.Variables.NAME_TYPE);
  var code = 'new Big(' + text_big1 + ').div(' + variable_big2 + ')';
  return [code, Blockly.JavaScript.ORDER_DIVISION];
};
Blockly.JavaScript['big_cmp'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.cmp(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_SUBTRACTION];
};
Blockly.JavaScript['big_modulo'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.mod(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_SUBTRACTION];
};
Blockly.JavaScript['big_pow'] = function(block) {
  var variable_name = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Variables.NAME_TYPE);
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_name + '.pow(' + value_name + ')';
  return [code, Blockly.JavaScript.ORDER_MULTIPLICATION];
};






Blockly.JavaScript['big_chiffres'] = function(block) {
  var variable_var = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var value_var = Blockly.JavaScript.valueToCode(block, 'VAR', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_var + ' = String( ' + value_var + ').split("");\n';
  code += 'for (var n in ' + variable_var + ') { ' + variable_var + '[n] = parseInt(' + variable_var + '[n]); }\n'; 
  return code;
};



Blockly.JavaScript['big_decimales'] = function(block) {
  var variable_var = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var value_var = Blockly.JavaScript.valueToCode(block, 'VAR', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_var + ' = String( ' + value_var + ').split("");\n';
  code += variable_var + " = " + variable_var + '.slice(' + variable_var + '.indexOf(".")+1,' + variable_var + '.length);\n';
  code += 'for (var n in ' + variable_var + ') { ' + variable_var + '[n] = parseInt(' + variable_var + '[n]); }\n'; 
  return code;
};

Blockly.JavaScript['big_aff'] = function(block) {
  var value_var = Blockly.JavaScript.valueToCode(block, 'VAR', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'document.getElementById("sortieNum").value += "\\n" + ' + value_var + ";\n";
  return code;
};

Blockly.JavaScript['big_efface'] = function(block) {
  var code = 'document.getElementById("sortieNum").value = "";\n';
  return code;
};
